



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python3的变量作用域规则和nonlocal关键字</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python3的变量作用域规则和nonlocal关键字</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:22:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>也许你已经觉得自己可以熟练使用python并能胜任许多开发任务，所以这篇文章是在浪费你的时间。不过别着急，我们先从一个例子开始：</p>
<pre class="prettyprint linenums"><code>i = 0<br />
def f():<br />
  print(i)<br />
  i += 1<br />
  print(i)

f()<br />
print(i)<br />
</code></pre>
<p>猜猜看输出是什么？你会说不就是0，1，1么，真的是这样吗？</p>
<pre class="prettyprint linenums"><code>&gt; python test.py<br />
Traceback (most recent call last):<br />
  File &quot;a.py&quot;, line 7, in &lt;module&gt;<br />
    f()<br />
  File &quot;a.py&quot;, line 3, in f<br />
    print(i)<br />
UnboundLocalError: local variable 'i' referenced before assignment<br />
</code></pre>
<p>这是为什么？如果你还不清楚产生错误的原因，那就请继续往下阅读吧！</p>
<blockquote><h4>本文索引</h4>
<ul><li><a href="#legb原则" rel="external nofollow noreferrer">LEGB原则</a></li>
<li><a href="#名字隐藏和暂时性死区" rel="external nofollow noreferrer">名字隐藏和暂时性死区</a></li>
<li><a href="#消除暂时性死区" rel="external nofollow noreferrer">消除暂时性死区</a></li>
<li><a href="#使用nonlocal声明闭包作用域变量" rel="external nofollow noreferrer">使用nonlocal声明闭包作用域变量</a></li>
<li><a href="#总结" rel="external nofollow noreferrer">总结</a></li></ul></blockquote>
<h2>LEGB原则</h2>
<p>变量的作用域，这是一个老生常谈的问题了。</p>
<p>在python中作用域规则可以简单的归纳为<code>LEGB原则</code>，也就是说，对于一个变量<code>name</code>，首先会从当前的作用域开始查找，如果它不在函数里那就从global开始，没找到就查找builtin作用域，如果它位于函数中，就先从local作用域查找，接着如果当前的函数是一个闭包，那么就查找外层闭包的作用域，也就是规则中的<code>E</code>，接着是global和builtin，如果都没找到<code>name</code>这个变量，则抛出<code>NameError</code>。</p>
<p>那么我们来看一段代码：</p>
<pre class="prettyprint linenums"><code>i = 100<br />
def f():<br />
  print(i)<br />
</code></pre>
<p>在这段代码中，print位于builtin作用域，i位于global，那么：</p>
<ol><li>在函数f中找不到这两个名字，所以从local向上查找，</li>
<li>首先f不是闭包，因此跳过闭包作用域的查找，</li>
<li>然后查找global，找到了i，但print还未找到，</li>
<li>然后查找builtin，找到了print的builtin模块里的一个函数。</li></ol>
<p>至此名字查找结束，调用找到的函数，输出结果100。</p>
<p>现在你可能更加疑惑了，既然查找规则按照<code>LEGB</code>的方向进行，那么test.py中的f不就应该找到i为global中的变量吗，为什么会报错呢？</p>
<h2>名字隐藏和暂时性死区</h2>
<p>在揭晓答案之前，我们先复习一下名字隐藏。</p>
<p>它是指一个声明在局部作用中的名字会隐藏外层作用域中的同名的对象。许多语言都遵守这一特性，python也不例外。</p>
<p>那么暂时性死区是什么呢？这是es6的一个概念，当你在局部作用域中定义了一个非全局的名字时，这个名字会绑定在当前作用域中，并将外部作用域的同名对象隐藏：</p>
<pre class="prettyprint linenums"><code>var i = 'hello'<br />
function f() {<br />
  i = 'world'<br />
  let i<br />
}<br />
</code></pre>
<p>这段代码中函数中的i被绑定在局部作用域（也就是函数体内）中，在绑定的作用域中可见，并将外部的名字隐藏，而对一个未声明的局部变量赋值会导致错误，所以上面的代码会引发<code>ReferenceError: i is not defined</code>。</p>
<p>对于python来说也是一样的问题，python代码在执行前首先会被编译成字节码，这就会导致某些时候实际执行的程序会和我们看到的产生出入。不过我们有<code>dis</code>模块帮忙，它可以输出python对象的字节码，下面我们就来看下经过编译后的<code>f</code>：</p>
<pre class="prettyprint linenums"><code>&gt; dis(f)

2           0 LOAD_GLOBAL              0 (print)<br />
            2 LOAD_FAST                0 (i)<br />
            4 CALL_FUNCTION            1<br />
            6 POP_TOP

3           8 LOAD_CONST               1 ('a')<br />
           10 STORE_FAST               0 (i)

4          12 LOAD_GLOBAL              0 (print)<br />
           14 LOAD_FAST                0 (i)<br />
           16 CALL_FUNCTION            1<br />
           18 POP_TOP<br />
           20 LOAD_CONST               0 (None)<br />
           22 RETURN_VALUE<br />
</code></pre>
<p>字节码的解释在<a href="https://docs.python.org/3/library/dis.html#python-bytecode-instructions" rel="external nofollow noreferrer">这里</a>。</p>
<p>其中<code>LOAD_FAST</code>和<code>STORE_FAST</code>是读取和存储local作用域的变量，我们可以看到，i变成了局部作用域的变量！而对i的赋值早于i的定义，所以报错了。</p>
<p>产生这种现象的原因也很简单，python对函数的代码是独立编译的，如果未加说明而在函数内对一个变量赋值，那么就认为你定义了一个局部变量，从而把外部的同名对象屏蔽了。这么做无可厚非，毕竟python没有独立的声明一个局部变量的语法，但结果就会造成我们看到的类似暂时性死区的现象。所以请允许我把es6的概念套用在python身上。</p>
<h2>消除暂时性死区</h2>
<p>既然知道问题的症结在于python无法区分局部变量的声明和定义，那么我们就来解决它。</p>
<p>对于一个可以区分声明和定义的语言来说是没有这种烦恼的，比如c：</p>
<pre class="prettyprint linenums"><code>int i = 0;<br />
void f(void)<br />
{<br />
  i++;<br />
  printf(&quot;%d\n&quot;, i); // 1<br />
  const char *i = &quot;hello&quot;;<br />
  printf(&quot;%s\n&quot;, i); // &quot;hello&quot;<br />
}<br />
</code></pre>
<p>python中不能这么做，但是我们可以换一个思路，声明一个变量是全局作用域的，这样不就解决了吗？</p>
<p><code>global</code>运算符就是为了这个目的而存在的，它声明一个变量始终是全局作用域的变量，因此只要存在global声明，那么当前作用域里的这个名字就是一个对同名全局变量的引用。改进后的函数如下：</p>
<pre class="prettyprint linenums"><code>def f():<br />
  global i<br />
  print(i)<br />
  i += 1<br />
  print(i)<br />
</code></pre>
<p>现在运行程序就会是你想要的结果了：</p>
<pre class="prettyprint linenums"><code>&gt; python test.py<br />
0<br />
1<br />
1<br />
</code></pre>
<p>如果你还是不放心，那么我们再来看看字节码：</p>
<pre class="prettyprint linenums"><code>&gt; dis(f)

3           0 LOAD_GLOBAL              0 (print)<br />
            2 LOAD_GLOBAL              1 (i)<br />
            4 CALL_FUNCTION            1<br />
            6 POP_TOP

4           8 LOAD_CONST               1 ('a')<br />
           10 STORE_GLOBAL             1 (i)

5          12 LOAD_GLOBAL              0 (print)<br />
           14 LOAD_GLOBAL              1 (i)<br />
           16 CALL_FUNCTION            1<br />
           18 POP_TOP<br />
           20 LOAD_CONST               0 (None)<br />
           22 RETURN_VALUE<br />
</code></pre>
<p>对于i的存取已经由<code>LOAD_GLOBAL</code>和<code>STORE_GLOBAL</code>接手了，没问题。</p>
<p>当然<code>global</code>也有它的局限性：</p>
<ul><li>一旦声明global，那么这个名字始终是global作用域的一个变量，不可以再是局部变量</li>
<li>名字必须存在于global里，因为python在运行时进行名字查找，所以你的变量在global里找不到的话对它的引用将会出错</li>
<li>接上一条，因为global限定了名字查找的范围，所以像闭包作用域的变量就找不到了</li></ul>
<p>事实上需要引用非global名字的需求是极其常见的，因此为了解决global的不足，python3引入了<code>nonlocal</code></p>
<h2>使用nonlocal声明闭包作用域变量</h2>
<p>假设我们有一个需求，一个函数需要知道自己被调用了多少次，最简单的实现就是使用闭包：</p>
<pre class="prettyprint linenums"><code>def closure():<br />
  count = 0<br />
  def func():<br />
    # other code<br />
    count += 1<br />
    print(f'I have be called {count} times')

  return func<br />
</code></pre>
<p>还是老问题，这样写对吗？</p>
<p>答案是不对，你又制造暂时性死区啦！</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; f=closure()<br />
&gt;&gt;&gt; f()<br />
Traceback (most recent call last):<br />
  File &quot;&lt;stdin&gt;&quot;, line 1, in &lt;module&gt;<br />
  File &quot;&lt;stdin&gt;&quot;, line 5, in func<br />
UnboundLocalError: local variable 'count' referenced before assignment<br />
</code></pre>
<p>这时候就要<code>nonlocal</code>出场了，它声明一个名字位于闭包作用域中，如果闭包作用域中未找到就报错。</p>
<p>所以修正后的函数如下：</p>
<pre class="prettyprint linenums"><code>def closure():<br />
  count = 0<br />
  def func():<br />
    # other code<br />
    nonlocal count<br />
    count += 1<br />
    print(f'I have be called {count} times')

  return func<br />
</code></pre>
<p>测试一下：</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; f=closure()<br />
&gt;&gt;&gt; f()<br />
I have be called 1 times<br />
&gt;&gt;&gt; f()<br />
I have be called 2 times<br />
&gt;&gt;&gt; f()<br />
I have be called 3 times<br />
&gt;&gt;&gt; f2=closure()<br />
&gt;&gt;&gt; f2()<br />
I have be called 1 times<br />
</code></pre>
<p>现在可以正常使用和修改闭包作用域的变量了。</p>
<h2>总结</h2>
<p>当然，在函数里修改外部变量往往会导致潜在的缺陷，但有时这样做又是对的，所以希望你在好好了解作用域规则的前提下合理地利用它们。</p>
<p>作用域规则可以总结为下：</p>
<ol><li>名字查找按照LEGB规则进行，如果当前代码在global中则从global作用域开始查找，否则从local开始</li>
<li>builtin作用域中是内置类型和函数，所以它们总是能被找到，前提是不要在局部作用域中对它们赋值</li>
<li>global中存放着所有定义在当前模块和导入的名字</li>
<li>local是局部作用域，存放在形成局部作用于的代码中有赋值行为的名字</li>
<li>闭包作用域是闭包函数的外层作用域，里面可以存放一些自定义的状态</li>
<li>global声明一个名字在global作用域中</li>
<li>nonlocal声明一个名字在闭包作用域中</li>
<li>最重要的一条，当你在能产生局部作用域的代码中对一个名字进行赋值，那么这个名字就会被认为是一个local作用域的变量从而屏蔽其他作用域中的同名对象</li></ol>
<p>只要记住这些规则你就可以和因作用域引起的各种问题说再见了。而且理解了这些规则还会为你探索更深层次的python打下坚实的基础，所以请将它牢记于心。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zodknq.html">JAVA面试逻辑题1</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93g4rr8.html">更加简洁易用&mdash;&mdash;wangEditor富文本编辑器新版本发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgngv9.html">JDBC连接池。。。转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lx6o9.html">安装mongodb</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnewk0q.html">yii2归档安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1ln19.html">【Linux】Centos部署MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12kdx8.html">LightOJ 13361336 - Sigma Function （找规律 &plus; 唯一分解定理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j033n0q.html">Robot Framework自动化测试---元素定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg26p78.html">Linux挖矿病毒 khugepageds详细解决步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m3w038.html">CentOS下MySQL的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwewl09.html">UVA548 tree的思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvymgg8.html">HDU 2389 Rain on your Parade 最大匹配&lpar;模板题&rpar;【HK算法】</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gymgeq.html">【LGR-049】洛谷7月月赛</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy34wgq.html">【vue】如何在 Vue-cli 创建的项目中引入 iView</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdg1ez9.html">OpenShift Origin 基本命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rny4xdq.html">zw版【转发&amp;&num;183&semi;台湾nvp系列Delphi例程】HALCON MirrorImage2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp4zv09.html">STL与泛型编程（第一周）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vw220q.html">Streamr助你掌控自己的数据&lpar;2&rpar;&mdash;&mdash;三种整合数据至Streamr的典型场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlxkek9.html">20165203 2017-2018-2 《Java程序设计》课程总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kozdd6q.html">Django加载静态网页模板</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1my21q.html">页面标准文档流、浮动层、float属性（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj34y09.html">语音识别中的CTC算法的基本原理解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj0moeq.html">linux dialog详解&lpar;图形化shell&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw15n8.html">Java公开课-06&period;单例</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y20dw8.html">springMVC引入Validation详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k7m209.html">js中函数的写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoz1znq.html">Windows下python3和python2同时安装python2&period;exe、python3&period;exe和pip2、pip3设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpyp0zq.html">mysq数据库相关操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge7e178.html">基于Nginx和Zookeeper实现Dubbo的分布式服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jzjwv8.html">git fatal&colon; 远程 origin 已经存在。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
